with cs110;
use  cs110;

with room;
with robot;

with Adagraph;
use  Adagraph;

procedure robot_main is
   height    : Positive;
   width     : Positive;
   num_doors : Positive;
   ben       : robot.robot_type;
   dorm      : room.room_type;
   X, Y      : Positive;
   del       : Float;
   
   procedure draw_tiles (X : positive; Y : Positive) is
   begin
      room.draw_tile(X => X, Y => Y);
      if X > 1 then room.draw_tile(X => X - 1, Y => Y); end if;
      if X < Room.Width then room.draw_tile(X => X + 1, Y => Y); end if;
      if Y > 1 then room.draw_tile(X => X, Y => Y - 1); end if;
      if Y < Room.Height then room.draw_tile(X => X, Y => Y + 1); end if;
   end draw_tiles;
   
begin
   Put (Item => "Please enter the height of the room:  ");
   Get_Line (Item => height);
   New_Line;
   
   Put (Item => "Please enter the width of the room:  ");
   Get_Line (Item => width);
   New_Line;
   
   Put (Item => "Please enter the number of doors in the room:  ");
   Get_Line (Item => num_doors);
   New_Line;
   
   Put (Item => "Please enter the X-location of robot:  ");
   Get_Line (Item => X);
   New_Line;
   
   Put (Item => "Please enter the Y-location of robot:  ");
   Get_Line (Item => Y);
   New_Line;
   
   Put (Item => "Please enter the delay:  ");
   Get_Line (Item => del);
   New_Line;
   
   room.create (R => dorm, height => height, width => width, num_doors => num_doors);
   robot.load (R => ben);
   robot.place (R => ben, X => X, Y => Y);
      
   Open_Graph_Window(X_Size => 2 * room.offset + width  * room.Tile_Size, 
                     Y_Size => 2 * room.offset + height * room.Tile_Size);

   room.draw(R => dorm);
   robot.draw(R => ben);
   loop
      delay standard.duration(del);
      robot.fetch(R => ben);
      exit when robot.end_of_program (R => ben);
      robot.location(R => ben, X => X, Y => Y);
      robot.execute(R => ben);
      --draw_tiles(X => X, Y => Y);
      room.draw(R => dorm);
      robot.draw(R => ben);
   end loop;
   
   Put (Item => "Press and key to continue .... ");
   Wait_for_KeyStroke;
   
   Close_Graph_Window;
   
end robot_main;